<?php
error_reporting(E_ALL ^ E_NOTICE);
error_reporting(0);


class Database{
    protected $connection;
    //public $currentDate = date('Y-m-d H:i:s');
    public $statusGet = array(0=>"In Active",1=>"Active");
    
    public $salutation = array(0=>"Mr.",1=>"Miss.",2=>"Mrs.");
    public $gender = array(0=>"Male",1=>"Female.",2=>"Unspecified");
    public $dataMessage = array(0=>"Inserted Successfully", 1 => "Already Exists", 2=>"Updated Successfully");
    
	
	
    public function connect()
    {
        $this->connection = new PDO("mysql:host=teamz.co.in;dbname=teamzco_db", "teamzco_admin", "Virt8344ual!@");
        //$this->connection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        
    }
    
    public function showTables($table){
        $this->connect();
        $query1 = "SHOW COLUMNS FROM ".$table;
        $query = $this->connection->prepare($query1);
        $query->execute();
        return $query->fetchAll(PDO::FETCH_ASSOC);
    }
	
	public function selectQuery($table,$where){
		$this->connect();
		$query1 = "SELECT * FROM `$table` ";
		if ($where) {
			$query1 .= $where;
		}
		//echo $query1; 
        //exit;
		$query = $this->connection->prepare($query1);
        $query->execute();
        return $query->fetchAll(PDO::FETCH_ASSOC);
	}
	
	public function selectSingle($table,$where){
		$this->connect();
		$query1 = "SELECT * FROM $table ";
		if ($where) {
			$query1 .= $where;
		}
		//echo $query1;
		//exit;
		$query = $this->connection->prepare($query1);
        $query->execute();
        return $query->fetch(PDO::FETCH_ASSOC);
	}
	
	public function selectMultiple($table,$where){
		$this->connect();
		$query1 = "SELECT * FROM $table ";
		if ($where) {
			$query1 .= $where;
		}
		
		//echo $query1;
        //exit;
		$query = $this->connection->prepare($query1);
        $query->execute();
        return $query->fetchAll(PDO::FETCH_ASSOC);
	}
	
	public function createQuerySingle($customQuery,$table,$where){
		$this->connect();
		$query1 = $customQuery;
		if ($where) {
			$query1 .= $where;
		}
		//echo $query1;
		//exit;
		$query = $this->connection->prepare($query1);
        $query->execute();
        return $query->fetch(PDO::FETCH_ASSOC);
	}
	
	public function createQueryAll($customQuery,$table,$where){
		$this->connect();
		$query1 = $customQuery;
		if ($where) {
			$query1 .= $where;
		}
		//echo $query1;
		//exit;
		$query = $this->connection->prepare($query1);
        $query->execute();
        return $query->fetchAll(PDO::FETCH_ASSOC);
	}
	
	
	public function query_insert($table,$data){ 
	    $values = "";
		$this->connect();
		$q = "INSERT INTO `" . $table . "` ";
		$v = '';
		$n = '';
        //$values= $q;
		foreach ( $data as $key => $val ) {
			$n .= "`$key`, ";
			$v.=":$key,";
           $values .="'$val',";
		}
		$values = $q."(" . rtrim ( $n, ', ' ) . ") VALUES (" . rtrim ( $values, ', ' ) . ");";
		$q .= "(" . rtrim ( $n, ', ' ) . ") VALUES (" . rtrim ( $v, ', ' ) . ");";
		//echo $values; 
		//exit;
		//$this->writeLog($q);
		$query = $this->connection->prepare($q);
		$result = $query->execute($data);
        $LAST_ID = $this->connection->lastInsertId();
        //echo $q;
        /*
        echo $q;
        exit; */
		//$this->writeLog($result);
		//$lastid = mysqli_insert_id($this->connect());
        //exit;
		return $LAST_ID;
	}
	
	public function query_update($table, $data, $where = '1') {
		$this->connect();
		$q="";
		//$this->writeLog(print_r($data));
		$q = "UPDATE `" . $table . "` SET ";
		foreach ( $data as $key => $val ) {
			$q .= "`$key`='" .  $val  . "', ";
		}
		$q = rtrim ( $q, ', ' ) . ' WHERE ' . $where . ';';
		//echo $q;
		//exit;
		$query = $this->connection->prepare($q);
		//$this->writeLog($q);
		return $query->execute($data);
	}
	
	public function writeLog($text) {
		file_put_contents ( realpath(dirname(__FILE__)) . "\\logs\\" . date ( "Y-m-d" ) . ".log", $text . "\n", FILE_APPEND  );
	}
	
	public function update($data)
	{
		$query = $this->connection->prepare(
			"UPDATE topics 
				SET 
					title = :title, 
					description = :description
				WHERE
					id = :id"
		);
	
		$data = [
			':id' => $data['id'],
			':title' => $data['title'],
			':description' => $data['description']
		];
	
		return $query->execute($data);
	}
	
	

	public function delete($id,$table) {
		$this->connect();
		$q = "DELETE FROM `$table`
				WHERE
					id = :id";
		//echo $q;
		$query = $this->connection->prepare($q);
		$data = [':id' => $id,];
		return $query->execute($data);
	}
	
	public function query_delete($idfield,$table,$idvalue) {
		$this->connect();
		$q = "DELETE FROM `$table`
				WHERE
					$idfield = :id";
		//echo $q;
		$query = $this->connection->prepare($q);
		$data = [':id' => $idvalue,];
		return $query->execute($data);
	}
	
	
	
	public function customerPermission(){
		//$_SESSION['USER_NAME'];
		if(!$_SESSION['CUSTOMER_USER_ID']){
			header("Location:my-account.php");
		} 
	}
	
	public function checkOutPermission(){
		//$_SESSION['USER_NAME'];
		if(!$_SESSION['ORDER_ID']){
			header("Location:product-page.php");
		} 
	}
	
	public function uploadFileOld($file) {
		if ($_FILES [$file] ["error"] == 0 || $_FILES [$file] ["error"] == 4) {
			if ($_FILES [$file] ["error"] != 4) {
				$folder_path = "products/";
				$target_path = "/" . $folder_path;
				$fileType = explode ( ".", basename ( $_FILES [$file] ['name'] ) );
				$fileExtension = $fileType [count ( $fileType ) - 1];
				$fileName = time () . "_" . substr ( $_FILES [$file] ['name'], 0, strlen ( $_FILES [$file] ['name'] ) - strlen ( $fileExtension ) - 1 ) . "." . $fileExtension;
				//echo $file;
				$target_path = $target_path . $fileName;
				if (move_uploaded_file ( $_FILES [$file] ['tmp_name'], $target_path )) {
					return $fileName;
				} else {
					return false;
				}
			} else {
				return 'nofile';
			}
		}
		return false;
	}
	
	public function uploadFile($file, $path) { 
		//echo $_FILES [$file] ["error"];
		if ($_FILES [$file] ["error"] == 0 || $_FILES [$file] ["error"] == 4) {
			if ($_FILES [$file] ["error"] != 4) {
				$folder_path = $path."/";
				$target_path =  "/".$folder_path;
				$fileType = explode ( ".", basename ( $_FILES [$file] ['name'] ) );
				$fileExtension = $fileType [count ( $fileType ) - 1];
				$fileName = time () . "_" . substr ( $_FILES [$file] ['name'], 0, strlen ( $_FILES [$file] ['name'] ) - strlen ( $fileExtension ) - 1 ) . "." . $fileExtension;
				//echo "..".$target_path;
				$target_path = $folder_path . $fileName;
                //echo $fileName;
                
				if (move_uploaded_file ( $_FILES [$file] ['tmp_name'], $target_path )) {
					return ADMIN_HEADER_TEXT.$folder_path . $fileName;
				} else {
					return false;
				}
			} else {
				return 'nofile';
			}
		}
		return false;
	}
	
	public function paggination($data, $count,$link,$currentpage){
		$a = ceil(count($data)/$count); 
		$last = count($data) % $count ;
		$current =  $currentpage;
		$pagination = '<ul class="pagination"><li><a href="'.$link.'?upper=0&lower='.$count.'"> << </a></li>';
		for($i=0;$i<$a;$i++){ 
			$currentCount = $i*$count;
			if($current == $currentCount){
				$class = 'class="active"';
			} else {
				$class = '';
			}
			$page = $i+1;
			$pagination .= '<li '.$class.'><a href="'.$link.'?upper='.$currentCount.'&lower='.$count.'"> '.$page.' </a></li>';
		}
		$pagination .= '<li><a href="'.$link.'?upper='.$currentCount.'&lower='.$count.'"> >> </a></li>';
		return $pagination;
	}
	
	public function pagginationNew($data, $count,$link,$currentpage){
		$a = ceil(count($data)/$count); 
		$last = count($data) % $count ;
		$current =  $currentpage;
		$pagination = '<ul class="pagination"><li><a href="'.$link.'?upper=0&lower='.$count.'"> << </a></li>';
		for($i=0;$i<$a;$i++){ 
			$currentCount = $i*$count;
			if($current == $currentCount){
				$class = 'class="active"';
			} else {
				$class = '';
			}
			$page = $i+1;
			$pagination .= '<li '.$class.'><a href="'.$link.'?upper='.$currentCount.'&lower='.$count.'"> '.$page.' </a></li>';
		}
		$pagination .= '<li><a href="'.$link.'?upper='.$currentCount.'&lower='.$count.'"> >> </a></li>';
		return $pagination;
	}
	
	function dateFormat($in, $out, $date) {
		$reg = '^([-/\ \.Yymndj]{8,10})$';
		if (! @ereg ( $reg, $in . $out ))
			return 1;
		$date = @ereg_replace ( '[/\ \.]', '-', $date );
		$_date = explode ( '-', $date );
		$date = sprintf ( '%02u', $_date [0] ) . sprintf ( '%02u', $_date [1] ) . sprintf ( '%02u', $_date [2] );
		
		$in = @ereg_replace ( '[/\ \.-]', '', $in );
		for($i = 0; $i < strlen ( $in ); $i ++) {
			$v = $in [$i];
			
			if (@ereg ( '[Y]', $v ))
				$len = 4;
			elseif (@ereg ( '[ymndj]', $v ))
				$len = 2;
			
			$dt [$v] = substr ( $date, 0, $len );
			$date = substr ( $date, $len );
			
			if (@ereg ( '[Yy]', $v ))
				$v == 'y' ? $dt ['Y'] = ($dt [$v] <= date ( $v ) ? '20' . $dt [$v] : '19' . $dt [$v]) : $dt ['y'] = substr ( $dt [$v], 2 );
			elseif (@ereg ( '[mn]', $v ))
				$v == 'n' ? $dt ['m'] = $dt [$v] : $dt ['n'] = ( int ) $dt [$v];
			elseif (@ereg ( '[dj]', $v ))
				$v == 'j' ? $dt ['d'] = $dt [$v] : $dt ['j'] = ( int ) $dt [$v];
		}
		
		$j = 0;
		$o_dt = $sp = array ();
		for($i = 0; $i < strlen ( $out ); $i ++) {
			$v = $out [$i];
			
			if (! @ereg ( '[Yymndj]', $v ))
				$sp [$j ++] = $v;
			else
				$o_dt [] = $dt [$v];
		}
		
		$ret = $o_dt [0] . @$sp [0] . $o_dt [1] . @$sp [1] . $o_dt [2];
		
		return $ret;
	}
	
	public function dateFormatToDbase($date) {
		return $this->dateFormat ( "d-m-Y", "Y-m-d", $date );
	}
	
	public function dateFormatToDisplay($date) {
		return $this->dateFormat ( "Y-m-d", "d-m-Y", $date );
	}
	
	public function sendMail($message, $to, $from, $subject,$cc="") {
		$message = stripcslashes($message);
		$headers = "MIME-Version: 1.0\r\n";
		$headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
		$headers .= "From: " . MARFIAN . " <" . $from . ">\r\n";
		$headers .= "Reply-To: " . MARFIAN. " <" . $to . ">\r\n";
		if($cc){
			$headers .= "cc: " . MARFIAN . " <" . $from . ">\r\n";
		}
		$html = "<table width=\"849\" cellpadding=\"2\" cellspacing=\"0\" style=\"border-width:1px; border-color:#e2e2e2; border-style:solid\">
            <tr>
              <td colspan=\"2\" bgcolor=\"#EFEFEF\" style=\"border-bottom:solid; border-bottom-color:#CCCCCC; border-bottom-width:1px;font-family:Verdana;font-size:18px; font-weight:600\">" . LOGOIMAGE . "</td>
            </tr>
            <tr>
            <td colspan=\"2\" >";
		$html .= $message;
		$html .= "<br><br><br><br><span style=\"float:left\">With Best Regards,</span><br><span style=\"color: #004BA1;font-weight: bold; float:left;\">" . ADMIN_HEADER_TEXT . "</span><br></td></tr><tr><td height=\"26\" colspan=\"2\" align=\"center\" bgcolor=\"#EFEFEF\" style=\"border-bottom:solid; border-bottom-color:#CCCCCC; border-bottom-width:1px\"><span style=\"font-size:11px;font-family:Tahoma;font-weight:bold;\"><a href=\"" . SITEURL . "\" target=\"_blank\" title=\"" . ADMIN_HEADER_TEXT . "\" >" . ADMIN_HEADER_TEXT . "</a></span></td></tr></table>";
		
				//echo $html;
         
		//$this->writeLog($html);
        //echo $to. $subject. $html. $headers. "===";
        //exit;
		@mail ( $to, $subject, $html, $headers );
	}
	
	public function sendMailPlain($message, $to, $from, $subject,$cc="") {
		$message = stripcslashes($message);
		$headers = "MIME-Version: 1.0\r\n";
		$headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
		$headers .= "From: some <" . $from . ">\r\n";
		$headers .= "Reply-To: some <" . $to . ">\r\n";
		mail ( $to, $subject, $message, $headers );
		exit;
	}
	
	
	
	
	
	
	
    
    public function userPermission(){
		//$_SESSION['USER_NAME'];
		if(!$_SESSION['USER_NAME']){
			header("Location:login.php");
		} else {
			//header("Location:");
		}
	}
    
    public function generateRandomString($length = 4) {
        $characters = '0123456789';
        $charactersLength = strlen($characters);
        $randomString = '';
        for ($i = 0; $i < $length; $i++) {
            $randomString .= $characters[rand(0, $charactersLength - 1)];
        }
        return $randomString;
    }
    
    
    public function generateRandomStringAlphaNumeric($length = 4) {
        $characters = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $charactersLength = strlen($characters);
        $randomString = '';
        for ($i = 0; $i < $length; $i++) {
            $randomString .= $characters[rand(0, $charactersLength - 1)];
        }
        return $randomString;
    }
    
   
    
    public function createTable($table){ 
        $this->connect();
        $q = "CREATE TABLE IF NOT EXISTS `".$table[0]."` (";
        foreach ( $table[1] as $key => $val ) {
			$q .= $val[0]." " .  $val[1] ." " . $val[2] .", ";
		}
        $q = rtrim ( $q, ', ' ) . ' ) ENGINE=InnoDB ;';
        //echo $q; 
        //print_r($table);
        //exit;
        $query = $this->connection->prepare($q);
        return $query->execute();
	}
        
        
    
    public function getProjectRoot(){
        $url = explode("/",$_SERVER['REQUEST_URI']);
        //header("Location:http://".$_SERVER["SERVER_NAME"]."/".$url[1]."/admin/admin_5/index.php");
        $url[0] = $_SERVER['SERVER_NAME'];
        return $url ;
    }
    
    
    public function addTextToImage($studentName, $imagewithpath){
        // Create Image From Existing File
        $jpg_image = imagecreatefromjpeg($imagewithpath);
        // Allocate A Color For The Text
        $white = imagecolorallocate($jpg_image, 255, 255, 255);
        // Set Path to Font File
        $font_path = 'arial.ttf';
        // Set Text to Be Printed On Image
        $text = "This is a sunset!";
        // Print Text On Image
        //imagettftext($jpg_image, 25, 0, 75, 300, $white, $font_path, $text);
        imagestring($jpg_image,5,126,22,$text,$white);
        // Send Image to Browser
        header('Content-type: image/jpeg');
        $image = imagejpeg($jpg_image);
        //imagedestroy($jpg_image);
        //return $image;
        // Clear Memory
    }
	
	function curlFunction($url,$postfields){
        $ch = curl_init();
        // set URL and other appropriate options
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $postfields);
        
        curl_setopt($ch, CURLOPT_HEADER, false);
        $result = curl_exec($ch);
        curl_close($ch);
    }
}
?>