<?php
include_once("data.php");
date_default_timezone_set('Asia/Kolkata');
class user extends Database{
	
	private $userModel = "users";
	private $leadsModel = "leads";
	private $projects = "projects";
	private $servicesModel = "services";
	private $payroll = "payroll";
	private $portfolio = "portfolio";
	private $tips = "tips";
    private $notifications = "notifications";
    private $vendorsModel = "vendors";
	private $salaryModel = "salary";
	private $expensesModel = "expenses";
	private $trackingModel = "tracking";
	private $ordersModel = "orders";
	private $packagesModel = "packages";
	private $razorpay_order = "razorpay_order";
	private $pricingModel = "pricing";
	private $leaveModel = "leaves";
	private $paymentsModel = "payments";
	private $domainsModel = "domains";
	private $employees = "employees";
	private $appointments = "appointments";
	private $settingsModel = "settings";
	private $attendance = "attendance";
	private $tasks = "tasks";
	private $proposals = "proposals";
	private $invoices = "invoices";
	
    //`mobilenumber`, `name`, `mailid`, `otp`, `otp_status`, `country`, `pincode`, `description`, `profile_image`, `mobileos`, `ipaddress`, `imeinumber`
	
	public function userField() {
        $userFieldDisplay = array("mobilenumber"=>"mobilenumber", "name"=>"name", "mailid"=>"mailid", "otp"=>"otp", "otp_status"=>"otp_status", "country"=>"country", "pincode"=>"pincode", "description"=>"description", "profile_image"=>"profile_image", "mobileos"=>"mobileos","ipaddress"=>"ipaddress", "imeinumber"=>"imeinumber", "mobile_change"=>"mobile_change", "register_level_status"=>"register_level_status");
        return $userFieldDisplay; 
    }
    
    
	
	public function userInsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->userModel, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
	
	public function projectsInsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->projects, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
	
	public function tasksInsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->tasks, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
	public function proposalsInsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->proposals, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
	public function invoicesinsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->invoices, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
	
		public function employeesInsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->employees, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
	
	public function payrollInsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->payroll, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
	
	
	public function attendanceInsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->attendance, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
	
	
	public function salaryInsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->salaryModel, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
	 
	 public function appointmentsInsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->appointments , $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
		public function leadsInsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->leadsModel, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
	
	public function vendorsInsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->vendorsModel, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
	
	public function expensesInsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->expensesModel, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
	
	public function trackingInsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->trackingModel, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
	
	public function paymentsInsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->paymentsModel, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
	
	public function domainsInsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->domainsModel, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
	
	
    public function ordersInsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->ordersModel, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
	
	
	public function portfolioInsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->portfolio, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
	
	public function servicesInsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->servicesModel, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
	
	public function packagesInsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->packagesModel, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
	
	public function wishInsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->wishList, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}

    public function leaveInsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->leaveModel, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}

	
	public function userList($condition){
		$this->connect();
        $result = $this->selectQuery($this->userModel,$condition);
        return $result;
    }
    
    public function leadsList($condition){
		$this->connect();
        $result = $this->selectQuery($this->leadsModel,$condition);
        return $result;
    }
    
    public function salaryList($condition){
		$this->connect();
        $result = $this->selectQuery($this->salaryModel,$condition);
        return $result;
    }
    
    public function vendorsList($condition){
		$this->connect();
        $result = $this->selectQuery($this->vendorsModel,$condition);
        return $result;
    }
    
    public function expensesList($condition){
		$this->connect();
        $result = $this->selectQuery($this->expensesModel,$condition);
        return $result;
    }
    
    public function appointmentsList($condition){
		$this->connect();
        $result = $this->selectQuery($this->appointments,$condition);
        return $result;
    }
    
    public function attendanceList($condition){
		$this->connect();
        $result = $this->selectQuery($this->attendance,$condition);
        return $result;
    }
    
    public function proposalsList($condition){
		$this->connect();
        $result = $this->selectQuery($this->proposals,$condition);
        return $result;
    }
    
    public function invoicesList($condition){
		$this->connect();
        $result = $this->selectQuery($this->invoices,$condition);
        return $result;
    }
    
    
    public function trackingList($condition){
		$this->connect();
        $result = $this->selectQuery($this->trackingModel,$condition);
        return $result;
    }
    
    public function paymentsList($condition){
		$this->connect();
        $result = $this->selectQuery($this->paymentsModel,$condition);
        return $result;
    }
    
    public function domainsList($condition){
		$this->connect();
        $result = $this->selectQuery($this->domainsModel,$condition);
        return $result;
    }
    
    public function ordersList($condition){
		$this->connect();
        $result = $this->selectQuery($this->ordersModel,$condition);
        return $result;
    }
    
    public function packagesList($condition){
		$this->connect();
        $result = $this->selectQuery($this->packagesModel,$condition);
        return $result;
    }
    
    public function servicesList($condition){
		$this->connect();
        $result = $this->selectQuery($this->servicesModel,$condition);
        return $result;
    }
    
    public function tasksList($condition){
		$this->connect();
        $result = $this->selectQuery($this->tasks,$condition);
        return $result;
    }
    
    public function projectsList($condition){
		$this->connect();
        $result = $this->selectQuery($this->projects,$condition);
        return $result;
    }
    
    public function leaveList($condition){
		$this->connect();
        $result = $this->selectQuery($this->leaveModel,$condition);
        return $result;
    }
    
     public function employeesList($condition){
		$this->connect();
        $result = $this->selectQuery($this->employees,$condition);
        return $result;
    }
    
     public function payrollList($condition){
		$this->connect();
        $result = $this->selectQuery($this->payroll,$condition);
        return $result;
    }
    
    public function pricingList($condition){
		$this->connect();
        $result = $this->selectQuery($this->pricingModel,$condition);
        return $result;
    }
    

    public function userSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->userModel,$condition);
		return $result;
	}
	
	 public function tasksSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->tasks,$condition);
		return $result;
	}
	
	 public function projectsSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->projects,$condition);
		return $result;
	}
	 
	 public function expensesSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->expensesModel,$condition);
		return $result;
	}
	
    public function vendorsSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->vendorsModel,$condition);
		return $result;
	}
	
	public function eventSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->userevents,$condition);
		return $result;
	}
	
	public function attendanceSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->attendance,$condition);
		return $result;
	}
	
	public function appointmentsSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->appointments,$condition);
		return $result;
	}
	
	public function servicesSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->servicesModel,$condition);
		return $result;
	}
	
	public function invoicesSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->invoices,$condition);
		return $result;
	}
	
	public function propsoalsSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->propsoals,$condition);
		return $result;
	}
	
	 public function employeesSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->employees,$condition);
		return $result;
	}
    
     public function payrollSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->payroll,$condition);
		return $result;
	}
    
    
    public function leadsSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->leadsModel,$condition);
		return $result;
	}
	
	public function leaveSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->leaveModel,$condition);
		return $result;
	}
	
	public function settingsSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->settingsModel,$condition);
		return $result;
	}
	
	
	public function trackingSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->trackingModel,$condition);
		return $result;
	}

    public function packagesSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->packagesModel,$condition);
		return $result;
	}
	
	public function paymentsSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->paymentsModel,$condition);
		return $result;
	}

    public function domainsSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->domainsModel,$condition);
		return $result;
	}
	
	public function salarySingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->salaryModel,$condition);
		return $result;
	}
	public function ordersSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->ordersModel,$condition);
		return $result;
	}
	
	public function userValidUpto($condition){
	    $this->connect();
	    $query = $this->connection->prepare("select * from users where valid_upto >= curdate()".$condition);
        $query->execute();
		$result = $query->fetchAll(PDO::FETCH_ASSOC);
		return $result;
	}
	
	public function IKYmissesYou($condition){
	    $this->connect();
	    $query = $this->connection->prepare("select * from users where `last_seen` < now() - INTERVAL 10 day".$condition);
        $query->execute();
		$result = $query->fetchAll(PDO::FETCH_ASSOC);
		return $result;
	}
	
	public function paymentDue($condition){
	    $this->connect();
	    $query = $this->connection->prepare("select * from users where `valid_upto` = DATE_ADD(CURDATE(), INTERVAL 3 DAY)");
        $query->execute();
		$result = $query->fetchAll(PDO::FETCH_ASSOC);
		return $result;
	}
	
	
	public function updateUser($data, $where){
		$result = $this->query_update($this->userModel, $data, $where);
		return $result;
	}
	
	public function updateWish($data, $where){
		$result = $this->query_update($this->wishList, $data, $where);
		return $result;
	}
	
	public function updatePackage($data, $where){
		$result = $this->query_update($this->packagesModel, $data, $where);
		return $result;
	}
	
	public function updateServices($data, $where){
		$result = $this->query_update($this->servicesModel, $data, $where);
		return $result;
	}

    public function updateLeave($data, $where){
		$result = $this->query_update($this->leaveModel, $data, $where);
		return $result;
	}
	
	 public function updateProposals($data, $where){
		$result = $this->query_update($this->proposals, $data, $where);
		return $result;
	}
	
	 public function updateInvoices($data, $where){
		$result = $this->query_update($this->invoices, $data, $where);
		return $result;
	}
	public function updateAttendance($data, $where){
		$result = $this->query_update($this->attendance, $data, $where);
		return $result;
	}
	
	public function updatePayments($data, $where){
		$result = $this->query_update($this->paymentsModel, $data, $where);
		return $result;
	}
	
	public function updateSalary($data, $where){
		$result = $this->query_update($this->salaryModel, $data, $where);
		return $result;
	}

    public function updateDomains($data, $where){
		$result = $this->query_update($this->domainsModel, $data, $where);
		return $result;
	}
	
	 public function updateSettings($data, $where){
		$result = $this->query_update($this->settingsModel, $data, $where);
		return $result;
	}
	
	public function updateappointments($data, $where){
		$result = $this->query_update($this->appointments, $data, $where);
		return $result;
	}
	
	
	public function updateorders($data, $where){
		$result = $this->query_update($this->ordersModel, $data, $where);
		return $result;
	}
	
	public function updateTracking($data, $where){
		$result = $this->query_update($this->trackingModel, $data, $where);
		return $result;
	}
	
	public function updateExpense($data, $where){
		$result = $this->query_update($this->expensesModel, $data, $where);
		return $result;
	}
	
	public function updateVendors($data, $where){
		$result = $this->query_update($this->vendorsModel, $data, $where);
		return $result;
	}
	
	public function updateLeads($data, $where){
		$result = $this->query_update($this->leadsModel, $data, $where);
		return $result;
	}
	
	public function updateTasks($data, $where){
		$result = $this->query_update($this->tasks, $data, $where);
		return $result;
	}

	public function updateProjects($data, $where){
		$result = $this->query_update($this->projects, $data, $where);
		return $result;
	}

	public function updateemployees($data, $where){
		$result = $this->query_update($this->employees, $data, $where);
		return $result;
	}
		
	public function updatePayroll($data, $where){
		$result = $this->query_update($this->payroll, $data, $where);
		return $result;
	}

	public function findContactsWithMbileNumber($mobilenumber){
	    $this->connect();
	    $query = $this->connection->prepare("SELECT * FROM users WHERE mobilenumber IN (SELECT contactnumber  FROM `contacts` WHERE `mobilenumber` LIKE '".$mobilenumber."') AND account_status = 1");
        $query->execute();
		$result = $query->fetchAll(PDO::FETCH_ASSOC);
		return $result;
	}
	
	public function updatePaidUser(){
	    $this->connect();
        $query = $this->connection->prepare("SELECT * FROM `users` WHERE `paid_upto`< now() AND premium_status = 1 AND status = 1");
        $query->execute();
        $result = $query->fetchAll(PDO::FETCH_ASSOC);
        for($i=0;$i<count($result);$i++){
            $data['premium_status'] = 0;
            $this->updateUser($data, " user_id = '".$result[$i]['user_id']."'");
        }
	}
	
	public function updateTrailUser(){
	    $this->connect();
        $query = $this->connection->prepare("SELECT * FROM `users` WHERE `paid_upto`< now() AND ftstatus = 1 AND status = 1");
        $query->execute();
        $result = $query->fetchAll(PDO::FETCH_ASSOC);
        for($i=0;$i<count($result);$i++){
            $data['ftstatus'] = 0;
            $this->updateUser($data, " user_id = '".$result[$i]['user_id']."'");
        }
	}
    
    public function categoryList($condition){
		$this->connect();
        $result = $this->selectQuery($this->categoryModel,$condition);
        
        for($i=0;$i<count($result);$i++){
            $itemList = $this->itemList(" WHERE category_id = '".$result[$i]['category_id']."' ORDER BY `fav_count` ASC");
            $result[$i]['item'] = $itemList;
        }
        return $result;
    }
	
	public function categorySingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->categoryModel,$condition);
        
        $itemList = $this->itemList(" WHERE category_id = '".$result['category_id']."' ORDER BY `fav_count` ASC");
        $result['item'] = $itemList;
        
		return $result;
	}
	
	public function categoryAddNew($condition){
	    $this->connect();
	    $query = $this->connection->prepare("SELECT * FROM category WHERE DATE(`created_date`) = DATE(NOW() - INTERVAL 1 DAY)");
        $query->execute();
		$result = $query->fetchAll(PDO::FETCH_ASSOC);
		return $result;
	}
	
	public function categorySingleGet($condition){
		$result = $this->selectSingle($this->categoryModel,$condition);
        
		return $result;
	}
	
	public function wishListGet($condition){
		$this->connect();
        $result = $this->selectQuery($this->wishList,$condition);
        return $result;
    }
    
    public function serviceListGet($condition){
		$this->connect();
        $result = $this->selectQuery($this->services,$condition);
        return $result;
    }
    
    
     public function portfolioListGet($condition){
		$this->connect();
        $result = $this->selectQuery($this->portfolio,$condition);
        return $result;
    }
	
	public function categorySingleNew($condition){
	    $this->connect();
		$result = $this->selectSingle($this->categoryModel,$condition);
        
		return $result;
	}
	
	public function userFavoriteCustom($mobilenumber){
		$this->connect();
		
		$query = $this->connection->prepare("SELECT * FROM `category` c WHERE c.category_id NOT IN (SELECT uf.category_id FROM `user_favorite` uf WHERE mobilenumber = '$mobilenumber' AND uf.status = 1) ORDER BY c.category_id LIMIT 0,1");
        $query->execute();
		$result = $query->fetchAll(PDO::FETCH_ASSOC);
		return $result;
	}
	
	public function userFavoriteCategoryCustom($mobilenumber){
		$this->connect();
		//echo "SELECT * FROM `category` c WHERE c.category_id NOT IN (SELECT uf.category_id FROM `user_favorite` uf WHERE mobilenumber = '$mobilenumber' AND uf.status = 1) AND c.status = 1 ORDER BY c.category_id LIMIT 0,1";
		$query = $this->connection->prepare("SELECT * FROM `category` c WHERE c.category_id NOT IN (SELECT uf.category_id FROM `user_favorite` uf WHERE mobilenumber = '$mobilenumber' AND uf.status = 1) AND c.status = 1 ORDER BY c.category_id LIMIT 0,1");
        $query->execute();
		$result = $query->fetchAll(PDO::FETCH_ASSOC);
		return $result;
	}
    
    public function itemList($condition){
		$this->connect();
        $result = $this->selectQuery($this->itemModel,$condition);
        for($i=0;$i<count($result);$i++){
            $categoryName =  $this->categorySingleGet(" WHERE category_id = '".$result[$i]['category_id']."'");
            $result[$i]['category_name'] = $categoryName['category_name'];
        }
        return $result;
    }
    
    public function itemListCustom($user_id, $item_id){
		$this->connect();
		//echo "SELECT * FROM `category` c WHERE c.category_id NOT IN (SELECT uf.category_id FROM `user_favorite` uf WHERE mobilenumber = '$mobilenumber' AND uf.status = 1) AND c.status = 1 ORDER BY c.category_id LIMIT 0,1";
		//echo "SELECT count(buddy_user_id) as buddy_count, (select name from `user` where user_id = uil.user_id) as username, (select name from `user` where buddy_user_id = uil.user_id) as buddyname,  FROM `user_item_like` uil WHERE uil.user_id='". $user_id."' AND item_id ='".$item_id."' AND uil.status = 1";
		$query = $this->connection->prepare("SELECT count(buddy_user_id) as buddy_count, (select name from `users` where user_id = uil.user_id) as username, (select name from `users` where buddy_user_id = uil.user_id) as buddyname  FROM `user_item_like` uil WHERE uil.user_id='". $user_id."' AND item_id ='".$item_id."' AND uil.status = 1 group by user_id");
        $query->execute();
		$result = $query->fetchAll(PDO::FETCH_ASSOC);
		return $result;
	}
	
	public function itemSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->itemModel,$condition);
		$categoryName =  $this->categorySingleGet(" WHERE category_id = '".$result['category_id']."'");
        $result['category_name'] = $categoryName['category_name'];
        
		return $result;
	}
    
    public function updateItem($data, $where){
		$result = $this->query_update($this->itemModel, $data, $where);
		return $result;
	}
    
	public function userFavoriteList($condition){
		$this->connect();
        $result = $this->selectQuery($this->userFavoriteModel,$condition);
        for($i=0;$i<count($result);$i++){
        $category_detail = $this->categorySingleGet(" WHERE category_id = '".$result[$i]['category_id']."'");
	    $result[$i]['category_name'] = $category_detail['category_name'];
        }
        return $result;
    }
    
    public function userFavoriteListDetail($condition){
		//$this->connect();
        $result = $this->selectQuery($this->userFavoriteModel,$condition);
        //echo "<pre>";
        //print_r($result);
        for($i=0;$i<count($result);$i++){
            
            $itemdetail = $this->itemSingle(" WHERE item_id='".$result[$i]['item_id']."'");
            //print_r($itemdetail);
            $result[$i]['itemdetail'] = $itemdetail;
            //$categorydetail = $this->categorySingleNew(" WHERE category_id=$result[$i]['category_id']");
            $categorydetail = $this->categorySingleGet(" WHERE category_id = '".$result[$i]['category_id']."'");
            $result[$i]['categorydetail'] = $categorydetail;
            $result[$i]['category_name'] = $categorydetail['category_name'];
            
        }
        
        return $result;
    }
	
	public function userFavoriteSingle($condition){
		$result = $this->selectSingle($this->userFavoriteModel,$condition);
		return $result; 
	}
    
    public function userFavoriteInsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		$error = $this->query_insert($this->userFavoriteModel, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
    
    public function updateUserFavorite($data, $where){
		$result = $this->query_update($this->userFavoriteModel, $data, $where);
		return $result;
	}
    
    public function contactList($condition){
        $result = $this->selectQuery($this->contactsModel,$condition);
        return $result;
    }

    public function wishList($condition){
        $result = $this->selectQuery($this->wishList,$condition);
        return $result;
    }
	
	public function contactSingle($condition){
		$result = $this->selectSingle($this->contactsModel,$condition);
		return $result;
	}
	
	public function insertContact($data){
		$error = $this->query_insert($this->contactsModel, $data);
		return $result;
	}
	
	public function updateContact($data, $where){
		$result = $this->query_update($this->contactsModel, $data, $where);
		return $result;
	}
    
	public function userContactBuddyList($condition){ 
		$this->connect();
		$query = $this->connection->prepare("SELECT * FROM users u,contacts c WHERE u.mobilenumber = c.mobilenumber AND u.account_status = '1' AND c.app_status=1".$condition." GROUP BY u.user_id"); 
		//$query = $this->connection->prepare("SELECT * FROM users u,contacts c WHERE u.mobilenumber IN (c.contactnumber, c.mobilenumber) AND c.app_status=1".$condition." GROUP BY u.user_id"); 
        $query->execute();
		$result = $query->fetchAll(PDO::FETCH_ASSOC);
		return $result;
	}
	
	public function userContactBuddyListNew($condition){ 
		$this->connect();
		$query = $this->connection->prepare("SELECT * FROM contacts c"); 
        $query->execute();
		$result = $query->fetchAll(PDO::FETCH_ASSOC);
		return $result;
	}
	
	public function userContactBuddyListWithMobileNumberMatch($mobilenumber, $condition){ 
		$this->connect();
		//$query = $this->connection->prepare("SELECT u.* FROM users u,contacts c WHERE u.mobilenumber = c.mobilenumber AND c.app_status=1".$condition);
		//$query = $this->connection->prepare("SELECT u.* FROM users u WHERE u.mobilenumber = '$mobilenumber' AND u.mobilenumber IN (SELECT c.mobilenumber FROM contacts c WHERE c.app_status='1')".$condition);
		//$query = $this->connection->prepare("SELECT c.* FROM contacts c WHERE c.mobilenumber = '$mobilenumber' AND c.mobilenumber AND c.app_status='1' IN (SELECT u.mobilenumber FROM users u)".$condition);
        //$query->execute();
		//$result = $query->fetchAll(PDO::FETCH_ASSOC);
		//SELECT u.* FROM contacts c, users u WHERE c.contactnumber = u.mobilenumber AND c.mobilenumber = '9941459392'
		//echo "SELECT u.* FROM contacts c, users u WHERE c.contactnumber = u.mobilenumber AND c.mobilenumber = '$mobilenumber'".$condition;
		$query = $this->connection->prepare("SELECT u.*, c.starred FROM contacts c, users u WHERE c.contactnumber = u.mobilenumber AND u.account_status = '1' AND c.mobilenumber = '$mobilenumber'".$condition);
        $query->execute();
		$result = $query->fetchAll(PDO::FETCH_ASSOC);
		
		return $result;
	}
	
	public function userContactBuddyListCount($mobilenumber, $condition){ 
		$this->connect();
		$query = $this->connection->prepare("SELECT u.* FROM users u WHERE u.mobilenumber IN (SELECT c.contactnumber FROM contacts c WHERE c.mobilenumber = '$mobilenumber')".$condition);
        $query->execute(); 
		$result = $query->fetchAll(PDO::FETCH_ASSOC);
		
		return $result;
	}
	
	public function userContactBuddyListWithMobileNumberMatchNew($mobilenumber, $word, $condition){ 
		$this->connect();
		
		//$query = $this->connection->prepare("SELECT u.* FROM users u WHERE name LIKE '%$word%' and u.mobilenumber IN (SELECT c.contactnumber FROM contacts c WHERE c.mobilenumber = '$mobilenumber' and c.app_status = 1)".$condition);
		$query = $this->connection->prepare("SELECT u.* FROM users u WHERE name LIKE '%$word%' AND u.account_status = 1 AND u.mobilenumber IN (SELECT c.contactnumber FROM contacts c WHERE c.mobilenumber = '$mobilenumber')".$condition);
        $query->execute(); 
		$result = $query->fetchAll(PDO::FETCH_ASSOC);
		return $result;
	}
	
	public function userContactBuddyListWithMobileNumberMatchNewStar($mobilenumber, $word, $condition, $contactstar){ 
		$this->connect();
		
		//$query = $this->connection->prepare("SELECT u.* FROM users u WHERE name LIKE '%$word%' and u.mobilenumber IN (SELECT c.contactnumber FROM contacts c WHERE c.mobilenumber = '$mobilenumber' and c.app_status = 1)".$condition);
		//echo "SELECT u.* FROM users u WHERE name LIKE '%$word%' AND u.account_status = 1 AND u.mobilenumber IN (SELECT c.contactnumber FROM contacts c WHERE c.mobilenumber = '$mobilenumber'".$contactstar.")".$condition;
		$query = $this->connection->prepare("SELECT u.* FROM users u WHERE name LIKE '%$word%' AND u.account_status = 1 AND u.mobilenumber IN (SELECT c.contactnumber FROM contacts c WHERE c.mobilenumber = '$mobilenumber'".$contactstar.")".$condition);
        $query->execute(); 
		$result = $query->fetchAll(PDO::FETCH_ASSOC);
		return $result;
	}
	
	
	
	
	//items, item image, item phone 
	public function buddyMatch($condition){
		$this->connect();
		
		//$query = $this->connection->prepare("SELECT COUNT(buddy.item_id) as item_count, (SELECT item_name FROM items i WHERE i.item_id = buddy.item_id) as item_name, (SELECT category_name FROM category c WHERE c.category_id = buddy.category_id) as category_name, (SELECT item_image FROM items i WHERE i.item_id = buddy.item_id) as item_image, (SELECT fav_count FROM items i WHERE i.item_id = buddy.item_id) as fav_count, (SELECT category_id FROM items i WHERE i.item_id = buddy.item_id) as category_id, (SELECT item_id FROM items i WHERE i.item_id = buddy.item_id) as item_id FROM user_favorite buddy, user_favorite me WHERE buddy.category_id = me.category_id AND buddy.item_id=me.item_id ".$condition." GROUP BY buddy.category_id, buddy.item_id"); 
		//echo "SELECT (SELECT item_name FROM items i WHERE i.item_id = buddy.item_id) as item_name, (SELECT category_name FROM category c WHERE c.category_id = buddy.category_id) as category_name, (SELECT item_image FROM items i WHERE i.item_id = buddy.item_id) as item_image,(SELECT item_color FROM items i WHERE i.item_id = buddy.item_id) as item_color, (SELECT fav_count FROM items i WHERE i.item_id = buddy.item_id) as fav_count, (SELECT category_id FROM items i WHERE i.item_id = buddy.item_id) as category_id, (SELECT item_id FROM items i WHERE i.item_id = buddy.item_id) as item_id, (SELECT u.profile_image FROM users u WHERE u.mobilenumber = buddy.mobilenumber) as buddy_profile_image, (SELECT u.profile_image FROM users u WHERE u.mobilenumber = me.mobilenumber) as my_profile_image FROM user_favorite buddy, user_favorite me WHERE buddy.category_id = me.category_id AND buddy.item_id=me.item_id ".$condition." GROUP BY buddy.category_id";
		$query = $this->connection->prepare("SELECT (SELECT item_name FROM items i WHERE i.item_id = buddy.item_id) as item_name, (SELECT category_name FROM category c WHERE c.category_id = buddy.category_id) as category_name, (SELECT item_image FROM items i WHERE i.item_id = buddy.item_id) as item_image,(SELECT item_color FROM items i WHERE i.item_id = buddy.item_id) as item_color, (SELECT fav_count FROM items i WHERE i.item_id = buddy.item_id) as fav_count, (SELECT category_id FROM items i WHERE i.item_id = buddy.item_id) as category_id, (SELECT item_id FROM items i WHERE i.item_id = buddy.item_id) as item_id, (SELECT u.profile_image FROM users u WHERE u.mobilenumber = buddy.mobilenumber) as buddy_profile_image, (SELECT u.profile_image FROM users u WHERE u.mobilenumber = me.mobilenumber) as my_profile_image FROM user_favorite buddy, user_favorite me WHERE buddy.category_id = me.category_id AND buddy.item_id=me.item_id ".$condition." GROUP BY buddy.category_id, buddy.item_id"); 
		//echo "SELECT (SELECT item_name FROM items i WHERE i.item_id = buddy.item_id) as item_name, (SELECT category_name FROM category c WHERE c.category_id = buddy.category_id) as category_name, (SELECT item_image FROM items i WHERE i.item_id = buddy.item_id) as item_image, (SELECT fav_count FROM items i WHERE i.item_id = buddy.item_id) as fav_count, (SELECT category_id FROM items i WHERE i.item_id = buddy.item_id) as category_id, (SELECT item_id FROM items i WHERE i.item_id = buddy.item_id) as item_id, (SELECT u.profile_image FROM users u WHERE u.mobilenumber = buddy.mobilenumber) as buddy_profile_image, (SELECT u.profile_image FROM users u WHERE u.mobilenumber = me.mobilenumber) as my_profile_image FROM user_favorite buddy, user_favorite me WHERE buddy.category_id = me.category_id AND buddy.item_id=me.item_id ".$condition." GROUP BY buddy.category_id, buddy.item_id";
		
        $query->execute();
		$result = $query->fetchAll(PDO::FETCH_ASSOC);
		return $result;
	}
	
	
	public function buddyMatchCategory($condition){
		$this->connect();
		
		//$query = $this->connection->prepare("SELECT COUNT(buddy.item_id) as item_count, (SELECT item_name FROM items i WHERE i.item_id = buddy.item_id) as item_name, (SELECT category_name FROM category c WHERE c.category_id = buddy.category_id) as category_name, (SELECT item_image FROM items i WHERE i.item_id = buddy.item_id) as item_image, (SELECT fav_count FROM items i WHERE i.item_id = buddy.item_id) as fav_count, (SELECT category_id FROM items i WHERE i.item_id = buddy.item_id) as category_id, (SELECT item_id FROM items i WHERE i.item_id = buddy.item_id) as item_id FROM user_favorite buddy, user_favorite me WHERE buddy.category_id = me.category_id AND buddy.item_id=me.item_id ".$condition." GROUP BY buddy.category_id, buddy.item_id"); 
		//echo "SELECT (SELECT item_name FROM items i WHERE i.item_id = buddy.item_id) as item_name, (SELECT category_name FROM category c WHERE c.category_id = buddy.category_id) as category_name, (SELECT item_image FROM items i WHERE i.item_id = buddy.item_id) as item_image,(SELECT item_color FROM items i WHERE i.item_id = buddy.item_id) as item_color, (SELECT fav_count FROM items i WHERE i.item_id = buddy.item_id) as fav_count, (SELECT category_id FROM items i WHERE i.item_id = buddy.item_id) as category_id, (SELECT item_id FROM items i WHERE i.item_id = buddy.item_id) as item_id, (SELECT u.profile_image FROM users u WHERE u.mobilenumber = buddy.mobilenumber) as buddy_profile_image, (SELECT u.profile_image FROM users u WHERE u.mobilenumber = me.mobilenumber) as my_profile_image FROM user_favorite buddy, user_favorite me WHERE buddy.category_id = me.category_id AND buddy.item_id=me.item_id ".$condition." GROUP BY buddy.category_id";
		$query = $this->connection->prepare("SELECT (SELECT item_name FROM items i WHERE i.item_id = buddy.item_id) as item_name, (SELECT category_name FROM category c WHERE c.category_id = buddy.category_id) as category_name, (SELECT item_image FROM items i WHERE i.item_id = buddy.item_id) as item_image,(SELECT item_color FROM items i WHERE i.item_id = buddy.item_id) as item_color, (SELECT fav_count FROM items i WHERE i.item_id = buddy.item_id) as fav_count, (SELECT category_id FROM items i WHERE i.item_id = buddy.item_id) as category_id, (SELECT item_id FROM items i WHERE i.item_id = buddy.item_id) as item_id, (SELECT u.profile_image FROM users u WHERE u.mobilenumber = buddy.mobilenumber) as buddy_profile_image, (SELECT u.profile_image FROM users u WHERE u.mobilenumber = me.mobilenumber) as my_profile_image FROM user_favorite buddy, user_favorite me WHERE buddy.category_id = me.category_id ".$condition." GROUP BY buddy.category_id, buddy.item_id"); 
		//echo "SELECT (SELECT item_name FROM items i WHERE i.item_id = buddy.item_id) as item_name, (SELECT category_name FROM category c WHERE c.category_id = buddy.category_id) as category_name, (SELECT item_image FROM items i WHERE i.item_id = buddy.item_id) as item_image, (SELECT fav_count FROM items i WHERE i.item_id = buddy.item_id) as fav_count, (SELECT category_id FROM items i WHERE i.item_id = buddy.item_id) as category_id, (SELECT item_id FROM items i WHERE i.item_id = buddy.item_id) as item_id, (SELECT u.profile_image FROM users u WHERE u.mobilenumber = buddy.mobilenumber) as buddy_profile_image, (SELECT u.profile_image FROM users u WHERE u.mobilenumber = me.mobilenumber) as my_profile_image FROM user_favorite buddy, user_favorite me WHERE buddy.category_id = me.category_id AND buddy.item_id=me.item_id ".$condition." GROUP BY buddy.category_id, buddy.item_id";
		
        $query->execute();
		$result = $query->fetchAll(PDO::FETCH_ASSOC);
		return $result;
	}
	
	
	
	
	public function userItemRequestInsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->userItemRequestModel, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
	
	public function userItemRequestList($condition){
		$this->connect();
        $result = $this->selectQuery($this->userItemRequestModel,$condition);
        return $result;
    }
	
	public function userItemRequestSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->userItemRequestModel,$condition);
		return $result;
	}
	
	public function updateUserItemRequest($data, $where){
		$result = $this->query_update($this->userItemRequestModel, $data, $where);
		return $result;
	}
	
	
	
	
	public function userCategoryRequestInsert($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->userCategoryRequestModel, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
	
	public function userCategoryRequestList($condition){
		$this->connect();
        $result = $this->selectQuery($this->userCategoryRequestModel,$condition);
        return $result;
    }
	
	public function userCategoryRequestSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->userCategoryRequestModel,$condition);
		return $result;
	}
	
	public function updateUserCategoryRequest($data, $where){
		$result = $this->query_update($this->userCategoryRequestModel, $data, $where);
		return $result;
	}
	
	
	
	public function userPhoneNumberInsert($data){
		$error = $this->query_insert($this->userPhoneNumberHistory, $data);
		return $error;
	}
	
	public function userPhoneNumberList($condition){
		$this->connect();
        $result = $this->selectQuery($this->userPhoneNumberHistory,$condition);
        return $result;
    }
	
	public function userPhoneNumberSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->userPhoneNumberHistory,$condition);
		return $result;
	}
	
	public function updateUserPhoneNumber($data, $where){
		$result = $this->query_update($this->userPhoneNumberHistory, $data, $where);
		return $result;
	}
	
	
	public function userRequestNumberInsert($data){
		$error = $this->query_insert($this->userRequest, $data);
		return $error;
	}
	
	public function userRequestNumberList($condition){
		$this->connect();
        $result = $this->selectQuery($this->userRequest,$condition);
        for($i=0;$i<count($result);$i++){
            $requestMobileSingle = $this->userSingle(" WHERE mobilenumber = '".$result[$i]['mobilenumber']."'");
            $result[$i]['request_mobilenumber'] = $requestMobileSingle['mobilenumber'];
            $result[$i]['name'] = $requestMobileSingle['name'];
            $result[$i]['description'] = $requestMobileSingle['description'];
        }
        return $result;
    }
    
    public function userRequestList($condition){
		$this->connect();
        $result = $this->selectQuery($this->userRequest,$condition);
        return $result;
    }
    
    
    public function userRequestNumberListCustom($condition,$custom){
		$this->connect();
        $result = $this->selectQuery($this->userRequest, " WHERE request_type='".$custom."'".$condition);
        for($i=0;$i<count($result);$i++){
            
            $requestMobileSingle = $this->userSingle(" WHERE mobilenumber = '".$result[$i]['mobilenumber']."'");
            $result[$i]['request_mobilenumber'] = $requestMobileSingle['mobilenumber'];
            $result[$i]['name'] = $requestMobileSingle['name'];
            $result[$i]['description'] = $requestMobileSingle['description'];
        }
        return $result;
    }
    
    
    public function userRequestNumberListCustomNew($condition,$request,$mobilenumber){
		$this->connect();
		if($request){
		    $result = $this->selectQuery($this->userRequest, " WHERE mobilenumber = '".$mobilenumber."' AND request_type='".$request."'".$condition);
		} else{
            $result = $this->selectQuery($this->userRequest, " WHERE mobilenumber = '".$mobilenumber."'".$condition);
		}
        for($i=0;$i<count($result);$i++){
            
            $requestMobileSingle = $this->userSingle(" WHERE mobilenumber = '".$result[$i]['mobilenumber']."'");
            $result[$i]['request_mobilenumber'] = $result[$i]['request_mobilenumber'];
            $result[$i]['name'] = $requestMobileSingle['name'];
            $result[$i]['description'] = $requestMobileSingle['description'];
            $result[$i]['profile_image'] = $requestMobileSingle['profile_image'];
        }
        return $result;
    }
    
    public function userRequestListByOther($condition,$request,$mobilenumber){
		$this->connect();
		if($request){
		    $result = $this->selectQuery($this->userRequest, " WHERE request_mobilenumber = '".$mobilenumber."' AND request_type='".$request."'".$condition);
		} else{
            $result = $this->selectQuery($this->userRequest, " WHERE request_mobilenumber = '".$mobilenumber."'".$condition);
		}
        for($i=0;$i<count($result);$i++){
            
            $requestMobileSingle = $this->userSingle(" WHERE mobilenumber = '".$result[$i]['mobilenumber']."'");
            $result[$i]['request_mobilenumber'] = $result[$i]['request_mobilenumber'];
            $result[$i]['name'] = $requestMobileSingle['name'];
            $result[$i]['description'] = $requestMobileSingle['description'];
             $result[$i]['profile_image'] = $requestMobileSingle['profile_image'];
        }
        return $result;
    }
    
    
    public function userRequestNumberListCustomNew_backup($condition,$request,$mobilenumber){
		$this->connect();
		if($request){
		    $result = $this->selectQuery($this->userRequest, " WHERE mobilenumber = '".$mobilenumber."' AND request_type='".$request."'".$condition);
		} else{
            $result = $this->selectQuery($this->userRequest, " WHERE mobilenumber = '".$mobilenumber."'".$condition);
		}
        for($i=0;$i<count($result);$i++){
            
            $requestMobileSingle = $this->userSingle(" WHERE mobilenumber = '".$result[$i]['mobilenumber']."'");
            $result[$i]['request_mobilenumber'] = $requestMobileSingle['mobilenumber'];
            $result[$i]['name'] = $requestMobileSingle['name'];
            $result[$i]['description'] = $requestMobileSingle['description'];
        }
        return $result;
    }
	
	public function userRequestNumberSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->userRequest,$condition);
		return $result;
	}
	
	public function updateUserRequestNumber($data, $where){
		$result = $this->query_update($this->userRequest, $data, $where);
		return $result;
	}
	
	public function getTips($condition){
	    $this->connect();
        $result = $this->selectQuery($this->tips,$condition);
        return $result;
	}
	
		public function getNotifications($condition){
	    $this->connect();
        $result = $this->selectQuery($this->notifications,$condition);
        return $result;
	}
	
	public function getNotification($userNumber, $condition){
	    $this->connect();
	    
	    $condition1 = " WHERE mobilenumber = '".$userNumber."'";
	    $usermodel = $this->selectSingle($this->userModel, $condition1); //$userModel
	    
        $result = $this->selectQuery($this->notification," WHERE user_id = '".$usermodel['user_id']."'". $condition);
        return $result;
	}
	
	public function notificationInsert($data){
		$error = $this->query_insert($this->notification, $data);
		return $result;
	}
	
	public function updateNotification($data, $where){
		$result = $this->query_update($this->notification, $data, $where);
		return $result;
	}
	
	
	public function sameSweetInsert($userNumber, $buddyNumber, $samesweetcount){
	    $data['mobilenumber'] = $userNumber;
	    $data['buddy_mobilenumber'] = $buddyNumber;
	    $data['matching_count'] = $samesweetcount;
	    $data['date'] = date('Y-m-d');
	    $data['status'] = 1;
	    $samesweetDayCountCheck = $this->selectQuery($this->samesweet," WHERE mobilenumber = '".$userNumber."' AND buddy_mobilenumber = '".$buddyNumber."' AND date = '".$data['date']."'");
	    if($samesweetDayCountCheck){
	        return $samesweetDayCountCheck;
	    } else{
	        $success = $this->query_insert($this->samesweet, $data);
	        $samesweetDayCount = $this->selectQuery($this->samesweet," WHERE mobilenumber = '".$userNumber."' AND date = '".$data['date']."'");
		    return $samesweetDayCount;
	    }
	}
	
	public function sameSweetSelect($userNumber){
	    $data['mobilenumber'] = $userNumber;
	    $data['buddy_mobilenumber'] = $buddyNumber;
	    $data['matching_count'] = $samesweetcount;
	    $data['date'] = date('Y-m-d');
	    $data['status'] = 1;
	    
	    $samesweetDayCount = $this->selectQuery($this->samesweet," WHERE mobilenumber = '".$userNumber."' AND date = '".$data['date']."'");
		return $samesweetDayCount;
	}
	
	
	public function sameSweetList($condition){
		$this->connect();
        $result = $this->selectQuery($this->samesweet,$condition);
        return $result;
    }
	
	
	
	public function userBuddyItemLikeInsert($data){
		$check = $this->userBuddyItemList(" WHERE mobilenumber = '".$data['mobilenumber']."' AND buddynumber = '".$data['buddynumber']."' AND item_id = '".$data['item_id']."'");
		//print_r(count($check));
		if(!count($check)){
		    $error = $this->query_insert($this->useritemlike, $data);
		}
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
	
	public function userBuddyItemList($condition){
		$this->connect();
        $result = $this->selectQuery($this->useritemlike,$condition);
        return $result;
    }
	
	public function userBuddyItemLikeSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->useritemlike,$condition);
		return $result;
	}
	
	public function updateUserBuddyItemLike($data, $where){
		$result = $this->query_update($this->useritemlike, $data, $where);
		return $result;
	}
	
	
	
	
	
	public function userHistoryInsert($data){
		
		$error = $this->query_insert($this->userhistory, $data);
		
		return $error;
	}
	
	public function userHistoryList($condition){
		$this->connect();
        $result = $this->selectQuery($this->userhistory,$condition);
        return $result;
    }
	
	public function userHistorySingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->userhistory,$condition);
		return $result;
	}
	
	public function updateUserHistory($data, $where){
		$result = $this->query_update($this->userhistory, $data, $where);
		return $result;
	}
	
	
	
	
	
	public function fofmobile($buddymobilenumber, $cat_id, $item_id){
	    $this->connect();
	    //SELECT * FROM users WHERE mobilenumber IN (SELECT DISTINCT(B.contactnumber) FROM users A, contacts B, user_favorite C WHERE A.mobilenumber=B.mobilenumber AND B.contactnumber = C.mobilenumber AND A.mobilenumber=9578021977 AND C.item_id=1)
	    $query = $this->connection->prepare("SELECT * FROM users WHERE mobilenumber IN (SELECT DISTINCT(B.contactnumber) FROM users A, contacts B, user_favorite C WHERE A.mobilenumber=B.mobilenumber AND B.contactnumber = C.mobilenumber AND A.mobilenumber='".$buddymobilenumber."' AND C.item_id='".$item_id."' AND c.category_id = '".$cat_id."')"); 
		//echo "SELECT (SELECT item_name FROM items i WHERE i.item_id = buddy.item_id) as item_name, (SELECT category_name FROM category c WHERE c.category_id = buddy.category_id) as category_name, (SELECT item_image FROM items i WHERE i.item_id = buddy.item_id) as item_image, (SELECT fav_count FROM items i WHERE i.item_id = buddy.item_id) as fav_count, (SELECT category_id FROM items i WHERE i.item_id = buddy.item_id) as category_id, (SELECT item_id FROM items i WHERE i.item_id = buddy.item_id) as item_id, (SELECT u.profile_image FROM users u WHERE u.mobilenumber = buddy.mobilenumber) as buddy_profile_image, (SELECT u.profile_image FROM users u WHERE u.mobilenumber = me.mobilenumber) as my_profile_image FROM user_favorite buddy, user_favorite me WHERE buddy.category_id = me.category_id AND buddy.item_id=me.item_id ".$condition." GROUP BY buddy.category_id, buddy.item_id";
		
        $query->execute();
		$result = $query->fetchAll(PDO::FETCH_ASSOC);
		return $result;
	}
	
	
	function convertNumber(){
        $str = array(
                '0'=>'WT2',
                '1'=>'E8L',
                '2'=>'FOS',
                '3'=>'ZB2',
                '4'=>'AL3',
                '5'=>'3ZL',
                '6'=>'2Z9',
                '7'=>'HCU',
                '8'=>'UPM',
                '9'=>'WBK'
                
            );
        return $str;
    }
    
    function encodeMobile($mobilenumber){
        $string = '';
        $convertNum = $this->convertNumber();
        for($i=0;$i<strlen($mobilenumber);$i++){
            $string = $string.$convertNum[$mobilenumber[$i]];
        }
        return $string;
    }
    
    function decodeMobile($mobilenumber){
        //echo $mobilenumber;
        $string = '';
        $mobile = array();
        $sino = 1;
        for($i=0;$i<strlen($mobilenumber);$i++){
            $string = $string.$mobilenumber[$i];
            if($sino%3 == 0){
                
                //echo $string;
                //echo "<br/>";
                array_push($mobile, $string);
                $sino = 1;
                $string = "";
            } else{
                $sino++;
            }
        }
        //print_r($mobile);
        $string = "";
        $convertNum = $this->convertNumber();
        
        for($i=0;$i<count($mobile);$i++){
            $string = $string.array_search($mobile[$i], $convertNum);
        }
        return (int)$string;
    }
    
    public function getTemplate($condition){
        $apiKey = urlencode('NzMzNTUxNzU3NTQ5NzQ2NjQyNjU2ZjU0N2E3ODRkNzQ=');
 
    	// Prepare data for POST request
    	$data = array('apikey' => $apiKey);
     
    	// Send the POST request with cURL
    	$ch = curl_init('https://api.textlocal.in/get_templates/');
    	curl_setopt($ch, CURLOPT_POST, true);
    	curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
    	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    	$response = curl_exec($ch);
    	curl_close($ch);
    	
    	// Process your response here
    	echo $response;
    }
    
    public function smsSend($numbers_array){
        $apiKey = urlencode('NzMzNTUxNzU3NTQ5NzQ2NjQyNjU2ZjU0N2E3ODRkNzQ=');
	
	    // Message details
	    //$numbers = $numbers;
	    $sender = urlencode('600010');
	    $otpget = $this->generateRandomString(4);
	    
	    $messageOtp = "Hi there, thank you for sending your first test message from Textlocal. Get 20% off today with our code: ".$otpget.".";
	    
	    
    	$message = rawurlencode($messageOtp);
     
    	$numbers = implode(',', $numbers_array);
     
    	// Prepare data for POST request
    	$data = array('apikey' => $apiKey, 'numbers' => $numbers, "sender" => $sender, "message" => $message);
     
    	// Send the POST request with cURL
    	$ch = curl_init('https://api.textlocal.in/send/');
    	curl_setopt($ch, CURLOPT_POST, true);
    	curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
    	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    	$response = curl_exec($ch);
    	curl_close($ch);
    	
    	//https://api.textlocal.in/send/?apiKey=NzMzNTUxNzU3NTQ5NzQ2NjQyNjU2ZjU0N2E3ODRkNzQ=&sender=600010&numbers=919578021977&message=Hi%20there,%20thank%20you%20for%20sending%20your%20first%20test%20message%20from%20Textlocal.%20Get%2020%%20off%20today%20with%20our%20code:%201234.
    	
    	// Process your response here
    	//echo $response;
    	return $otpget;
    }
    
    
    public function smsSendSollu($numbers_array){
        $apiKey = urlencode('39C80BBAB6637441A59675E1494');
	
	    // Message details
	    //$numbers = $numbers;
	    $entityid = "1201159196208258034";
	    $otpget = $this->generateRandomString(4);
	    $messageOtp = "Your Verification Code is ".$otpget." - Sollu";
	    
    	$message = rawurlencode($messageOtp);
     
    	//$numbers = implode(',', $numbers_array);
    	$templateid = "1707161855070635817";
     
    	// Prepare data for POST request
    	//https://app.sollu.in/api/transactional_sms?apikey=39C80xxxx&message=Actual_DLT_approved_format_message_text&mnumber=xxxx&entityid=xxxxx&templateid=xxxxx&smstype=Trans
    	$data = array('apikey' => $apiKey, 'mnumber' => $numbers_array, "entityid" => $entityid, "message" => $message, "templateid" => $templateid, "smstype" => "Trans");
     
    	// Send the POST request with cURL
    	$ch = curl_init('https://app.sollu.in/api/transactional_sms');
    	curl_setopt($ch, CURLOPT_POST, true);
    	curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
    	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    	$response = curl_exec($ch);
    	curl_close($ch);
    	
    	// Process your response here
    	echo $response;
    	return $otpget;
    }
    
    
    
    public function randomiserInsert($data){
		
		$error = $this->query_insert($this->randomiser, $data);
		
		return $error;
	}
	
	public function randomiserList($condition){
		$this->connect();
        $result = $this->selectQuery($this->randomiser,$condition);
        return $result;
    }
	
	public function randomiserSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->randomiser,$condition);
		return $result;
	}
	
	public function updateRandomiser($data, $where){
		$result = $this->query_update($this->randomiser, $data, $where);
		return $result;
	}
	
	public function searchRandomiser($mobilenumber){
	    $this->connect();
	    $result = $this->selectQuery($this->userModel, " WHERE mobilenumber <> '".$mobilenumber."' ORDER BY RAND() LIMIT 1"); 
		//print_r($result);
		
		if($result){
		    $result1 = $this->selectQuery($this->randomiser, " WHERE mobilenumber = '".$mobilenumber."' AND buddynumber'".$result[0]['mobilenumber']."'"); 
		    //print_r($result1);
    		if($result1[0]['mobilenumber'] == $result[0]['mobilenumber']){
    		    echo "xxxxxxx";
    		    $this->searchRandomiser($mobilenumber);
    		} else {
    		    $data['buddynumber'] = $result[0]['mobilenumber'];
    		    $data['mobilenumber'] = $mobilenumber;
    		    $data['date'] = date('Y-m-d H:i:s');
    		    $data['status'] = 1;
    		    
    		    $this->randomiserInsert($data);
    		    //$query = $this->bestMatchSingle(" WHERE mobilenumber = '".$mobilenumber."' AND buddynumber = '".$buddynumber."'");
    		    $query = $this->userList(" WHERE mobilenumber = '".$result[0]['mobilenumber']."'");
    		    return $query;
		    }
		} 
	}
	
	
	
	public function bestmatchInsert($data){
		
		$error = $this->query_insert($this->bestmatch, $data);
		
		return $error;
	}
	
	public function bestmatchList($condition){
		$this->connect();
        $result = $this->selectQuery($this->bestmatch,$condition);
        return $result;
    }
	
	public function bestmatchSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->bestmatch,$condition);
		return $result;
	}
	
	public function updateBestmatch($data, $where){
		$result = $this->query_update($this->bestmatch, $data, $where);
		return $result;
	}
	
	
	
	public function findbestmatchLoop($mobilenumber, $gender){
	    $userSingle = $this->userSingle(" WHERE mobilenumber = '$mobilenumber'");
	    
	    $mobilenumberget = $this->bestmatchList(" WHERE mobilenumber = '".$mobilenumber."'");
	    $mobilenumberarray = array(strval($mobilenumber));
	    for($i=0;$i<count($mobilenumberget);$i++){
	        array_push($mobilenumberarray, strval($mobilenumberget[$i]['buddynumber']));
	    }
	    
	    $mobilenumberarray = implode("','", $mobilenumberarray);
	    
    	$userList = $this->userList(" WHERE mobilenumber not in  ('$mobilenumberarray') AND account_status = 1 AND gender in ('".$gender."')");
    	
    	
    	
    	if(count($userList)){
    	    for($i=0;$i<count($userList);$i++){
    	        //$userList = $this->userList(" WHERE mobilenumber != '$mobilenumber' AND account_status = 1 AND gender <> '".$gender."' AND TIMESTAMPDIFF(YEAR, '".$userSingle['dob']."', '".$userList[$i]['dob']."') ");
    	        //$userList = $this->userList(" WHERE mobilenumber != '$mobilenumber' AND account_status = 1 AND gender in ".$gender);
    	        $time=strtotime($userList[$i]['dob']);
    	        //$userList[$i]['age_diff'] =  date("Y",$time) - date("Y",strtotime($userSingle['dob']));
    	        $userList[$i]['age_diff'] =  $userList[$i]['dob'];
    	    }
    	    
    	    $sort = array();
            foreach($userList as $k=>$v) {
               $sort['age_diff'][$k] = $v['age_diff'];
               $sort['gender'][$k] = $v['gender'];
            }
    	    array_multisort($sort['age_diff'], SORT_DESC, $userList);
    	    
    	    return $userList;
    	} else {
    	    /*
    	    if($userSingle['gender'] == "Male"){
    	        $gender = array('Female', 'Others', 'Male');   
    	    } elseif($userSingle['gender'] == "Female"){
    	        $gender =array ('Male', 'Others','Female');   
    	    } elseif($userSingle['gender'] == "Others"){
    	        $gender = array('Male', 'Others','Female');
    	    } else {
    	        $gender = array('NULL');
    	    }
    	    $gender = implode("','",$gender);
    	    
    	    $this->findbestmatchLoop($mobilenumber, $gender);
    	    */
    	    $userList = array();
    	    return $userList;
    	}
    	
	}
	
	public function findbestmatch($mobilenumber){
		
    	$myuserfav = $this->userFavoriteList(" WHERE mobilenumber = '".$mobilenumber."'");
    	
    	$myuserfavitem = array();
    	$myuserfavcat = array();
    	for($k=0;$k<count($myuserfav);$k++){
    		$myuserfavitem[$k] = $myuserfav[$k]['item_id'];
    		$myuserfavcat[$k] = $myuserfav[$k]['category_id'];
    	}
    	$myuserfavitemlist = implode(",",$myuserfavitem);
    	$myuserfavcatlist = implode(",",$myuserfavcat);
    	
    	$categoryList = $this->categoryList(" WHERE status = 1");
    	$categoryCount = count($categoryList);
    	
    	
    	$userSingle = $this->userSingle(" WHERE mobilenumber = '$mobilenumber'");
    	
    	$userList = $this->findbestmatchLoop($mobilenumber, $userSingle['gender']);
    	
        //$userList = $this->findContactsWithMbileNumber($mobilenumber);
        if(count($userList)){
    	$sino=0;
    	for($i=0;$i<count($userList);$i++){
    		$matchuserfav = $this->userFavoriteList(" WHERE mobilenumber = '".$userList[$i]['mobilenumber']."' AND item_id IN ($myuserfavitemlist) AND category_id IN ($myuserfavcatlist)");
    		$mycount = count($matchuserfav)/$categoryCount*100;
    		$userList[$i]['percentage'] = $mycount;
    		
    	}
    	$sort = array();
        foreach($userList as $k=>$v) {
           $sort['percentage'][$k] = $v['percentage'];
           $sort['gender'][$k] = $v['gender'];
        }
        
    	array_multisort($sort['percentage'], SORT_DESC, $userList);
    	
    	return $userList;
        } else {
            return $userList;
        }
        
    }
    
    
    
    public function privacyPolicyInsert($data){
		
		$error = $this->query_insert($this->privacypolicy, $data);
		
		return $error;
	}
	
	public function privacyPolicyList($condition){
		$this->connect();
        $result = $this->selectQuery($this->privacypolicy,$condition);
        return $result;
    }
	
	public function privacypolicySingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->privacypolicy,$condition);
		return $result;
	}
	
	public function updatePrivacyPolicy($data, $where){
		$result = $this->query_update($this->privacypolicy, $data, $where);
		return $result;
	}
    
    public function termsandConditionsInsert($data){
		
		$error = $this->query_insert($this->termsandconditions, $data);
		
		return $error;
	}
	
	public function termsandConditionsList($condition){
		$this->connect();
        $result = $this->selectQuery($this->termsandconditions,$condition);
        return $result;
    }
	
	public function termsandConditionsSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->termsandconditions,$condition);
		return $result;
	}
	
	public function updatetermsandConditions($data, $where){
		$result = $this->query_update($this->termsandconditions, $data, $where);
		return $result;
	}
    
    public function razorPayInsert($data){
		
		$error = $this->query_insert($this->razorpay_order, $data);
		
		return $error;
	}
	
	public function razorPayList($condition){
		$this->connect();
        $result = $this->selectQuery($this->razorpay_order,$condition);
        return $result;
    }
	
	public function razorPaySingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->razorpay_order,$condition);
		return $result;
	}
	
	public function updateRazorPay($data, $where){
		$result = $this->query_update($this->razorpay_order, $data, $where);
		return $result;
	}
    
    public function notificationFireBase($deviceId, $body, $customer_id=false) {
    	/* $data = array(
    		'customer_id' 	=> $customer_id,
    		'message'		=> $body,
    		'status' 		=> 1,
    	);
    	$this->db->insert('notification',$data); */
    	
    	$url = "https://fcm.googleapis.com/fcm/send";
    	$serverKey = FIREBASE_API;
    	$title = "IKY APP";
    	$notification = array('title' =>$title, 'body' => $body, 'sound' => 'default', 'badge' => '1');
    	$tokens = $deviceId;
    	/*if(count($tokens) > 0)
    	{
    		foreach($tokens as $tok) {*/
    			$arrayToSend = array('to' => $tokens, 'notification' => $notification,'priority'=>'high');
    			$json = json_encode($arrayToSend);
    			$headers = array();
    			$headers[] = 'Content-Type: application/json';
    			$headers[] = 'Authorization: key='. $serverKey;
    			$ch = curl_init();
    			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    			curl_setopt($ch, CURLOPT_URL, $url);
    			curl_setopt($ch, CURLOPT_CUSTOMREQUEST,"POST");
    			curl_setopt($ch, CURLOPT_POSTFIELDS, $json);
    			curl_setopt($ch, CURLOPT_HTTPHEADER,$headers);
    			curl_setopt($ch, CURLOPT_HEADER, 0);
    			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); 
    			$response = curl_exec($ch);
    			echo $response;
    			curl_close($ch);
    		/*}
    	}*/
    }
    
    
    public function userFeedBack($data){
		//$check = $this->userList(" WHERE mobilenumber = '".$data['mobilenumber']."'");
		
		$error = $this->query_insert($this->userFeedBackModel, $data);
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
	
	public function userFeedBackList($condition){
		$this->connect();
        $result = $this->selectQuery($this->userFeedBackModel,$condition);
        return $result;
    }
    
    public function userFeedBackSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->userFeedBackModel,$condition);
		return $result;
	}
	
	 public function userFeedBackInsert($data){
		
		$error = $this->query_insert($this->userFeedBackModel, $data);
		
		return $error;
	}
	
	public function updateUserFeedBack($data, $where){
		$result = $this->query_update($this->userFeedBackModel, $data, $where);
		return $result;
	}
	
	
	
	public function feedbackList($condition){
        $result = $this->selectQuery($this->feedback,$condition);
        return $result;
    }
	
	public function feedbackSingle($condition){
		$result = $this->selectSingle($this->feedback,$condition);
		return $result;
	}
	
	public function insertFeedback($data){
		$error = $this->query_insert($this->feedback, $data);
		return $result;
	}
	
	public function updateFeedback($data, $where){
		$result = $this->query_update($this->feedback, $data, $where);
		return $result;
	}
	
	
	
	public function peopleInsert($data){
		$check = $this->userBuddyItemList(" WHERE mobilenumber = '".$data['mobilenumber']."' AND contactnumber = '".$data['contactnumber']."'");
		//print_r(count($check));
		if(!count($check)){
		    $error = $this->query_insert($this->people, $data);
		}
		//$error = "Mobile Number inserted successfully";
		
		return $error;
	}
	
	public function peopleList($condition){
		$this->connect();
        $result = $this->selectQuery($this->people,$condition);
        return $result;
    }
	
	public function peopleSingle($condition){
	    $this->connect();
		$result = $this->selectSingle($this->people,$condition);
		return $result;
	}
	
	public function updatePeople($data, $where){
		$result = $this->query_update($this->people, $data, $where);
		return $result;
	}
	
	
	public function countryCodeList($condition){
        $result = $this->selectQuery($this->country_code,$condition);
        return $result;
    }
	
	public function countryCodeSingle($condition){
		$result = $this->selectSingle($this->country_code,$condition);
		return $result;
	}
	
	public function insertCountryCode($data){
		$error = $this->query_insert($this->country_code, $data);
		return $result;
	}
	
	public function updateCountryCode($data, $where){
		$result = $this->query_update($this->country_code, $data, $where);
		return $result;
	}
	
	
	
	public function referralCodeInsert($data){
		
		$error = $this->query_insert($this->referralCode, $data);
		
		return $error;
	}
	
	public function referralCodeList($condition){
		$this->connect();
        $result = $this->selectQuery($this->referralCode,$condition);
        return $result;
    }
	
	public function referralCodeSingle($condition){
	    //echo $condition;
	    $this->connect();
		$result = $this->selectSingle($this->referralCode,$condition);
		return $result;
	}
	
	public function updateReferralCode($data, $where){
		$result = $this->query_update($this->referralCode, $data, $where);
		return $result;
	}
	
	
	
}
	
?>